package com.zhentao.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhentao.conment.SnowflakeIdWorker;
import com.zhentao.dto.ShopDto;
import com.zhentao.pojo.Shop;
import com.zhentao.service.ShopService;
import com.zhentao.mapper.ShopMapper;
import com.zhentao.vo.Result;
import org.springframework.stereotype.Service;

/**
* @author lzy
* @description 针对表【shop】的数据库操作Service实现
* @createDate 2025-05-10 10:17:00
*/
@Service
public class ShopServiceImpl extends ServiceImpl<ShopMapper, Shop>
    implements ShopService{

    @Override
    public Result AddShop(ShopDto shopDto) {
        SnowflakeIdWorker snowflakeIdWorker=new SnowflakeIdWorker(1,1);
        Shop shop = new Shop(snowflakeIdWorker.nextId(), shopDto.getName(), shopDto.getPrimary());
        System.err.println(shop);
        int insert = this.baseMapper.insert(shop);
        if (insert!=0){
            return Result.OK(null,"添加成功");
        }
        return Result.Err(null,"添加失败");
    }
}




