package com.zhentao.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhentao.conment.SnowflakeIdWorker;
import com.zhentao.conment.TokenUtils;
import com.zhentao.dto.UserLongin;
import com.zhentao.pojo.User;
import com.zhentao.service.UserService;
import com.zhentao.mapper.UserMapper;
import com.zhentao.vo.Result;
import org.springframework.stereotype.Service;

/**
* @author lzy
* @description 针对表【user】的数据库操作Service实现
* @createDate 2025-05-10 10:15:41
*/
@Service
public class UserServiceImpl extends ServiceImpl<UserMapper, User>
    implements UserService{



    @Override
    public Result longin(UserLongin userLongin) {

        User user = this.baseMapper.selectOne(new QueryWrapper<User>().eq("username", userLongin.getUsername()).eq("password", userLongin.getPassword()));


        if (user!=null){
            String jwtToken = TokenUtils.createJwtToken(user.getId().toString());
            return  Result.OK(jwtToken,"登录成功");
        }else {
            SnowflakeIdWorker snowflakeIdWorker=new SnowflakeIdWorker(1,1);

            User user1=new User();
            user1.setId(snowflakeIdWorker.nextId());
            user1.setPassword(userLongin.getPassword());
            user1.setUsername(userLongin.getUsername());
            this.baseMapper.insert(user1);
            String jwtToken = TokenUtils.createJwtToken(user1.getId().toString());
            return  Result.OK(jwtToken,"登录成功");
        }
    }
}




